uint8_t sendBuf[150];  // LEDに送信するデータを格納しておくバッファー

// 起動(リセット)後に以下のsetup関数が1回実行される
void setup() {
  // 下準備 使うピンを出力に設定
  pinMode(14, OUTPUT);  // チャネル1 Pin14, PC0
  pinMode(15, OUTPUT);  // チャネル2 Pin15, PC1
  pinMode(16, OUTPUT);  // チャネル3 Pin16, PC2
  pinMode(17, OUTPUT);  // チャネル4 Pin17, PC3
  pinMode(18, OUTPUT);  // チャネル5 Pin18, PC4
  pinMode(8, OUTPUT);   // LED

  // 1つめLEDの値をバッファーにセット
  sendBuf[0] = 255;  // 緑の値
  sendBuf[1] = 0;    // 赤の値
  sendBuf[2] = 0;    // 青の値

  // 2つめLEDの値をバッファーにセット
  sendBuf[3] = 0;    // 緑の値
  sendBuf[4] = 255;  // 赤の値
  sendBuf[5] = 0;    // 青の値

  // 3つめLEDの値をバッファーにセット
  sendBuf[6] = 0;    // 緑の値
  sendBuf[7] = 255;  // 赤の値
  sendBuf[8] = 255;  // 青の値

  sendLedData();  // バッファーのデータをアドレサブルRGBデバイスに送信
}

// setup関数の後、loop関数が繰り返し実行される
void loop() {
}

// バッファーのデータをアドレサブルRGB LEDに送信する関数
// 中身を変更する必要はない
void sendLedData() {
  uint8_t ch = 0x1F;  // 全チャネルに同じデータを送信
  uint16_t start = 0;
  uint8_t buf;
  uint16_t i = start;
  uint8_t mask = 0x80;
  uint16_t stp = 150;
  noInterrupts();
  while (true) {
    buf = sendBuf[i];
    while (true) {
      if ((buf & mask) == 0) {
        PORTC = ch;
        mask = mask >> 1;
        PORTC = 0;
        if (mask == 0) {
          i++;
          if (i == stp) {
            delayMicroseconds(350);  // 全てのデータ送信後はしばらくLOWにする
            interrupts();
            return;
          }
          mask = 0x80;
          break;
        }
        asm("nop");
        asm("nop");
        asm("nop");
        asm("nop");
        asm("nop");
      } else {
        PORTC = ch;
        asm("nop");
        asm("nop");
        asm("nop");
        asm("nop");
        asm("nop");
        asm("nop");
        asm("nop");
        asm("nop");
        mask = mask >> 1;
        if (mask == 0) {
          mask = 0x80;
          i++;
          if (i == stp) {
            PORTC = 0;
            delayMicroseconds(350);  // 全てのデータ送信後はしばらくLOWにする
            interrupts();
            return;
          }
          PORTC = 0;
          break;
        }
        PORTC = 0;
      }
    }
  }
}
